#include "project-defs.h"
#include "uart-api.h"

int main() {
	// Quand on lit ce code, on saisit bien l'intérêt de décomposer
	// son application en modules et de manipuler des abstractions.
	uartInitialise(115200);

	while (1) {
		uint8_t c;

		// Est-ce qu'un caractère est disponible en entrée ?
		if (uartGetBlock(&c, 1)) {
			// Si c'est une minuscule, le convertir en majuscule.
			if (c >= 'a' && c <= 'z') {
				c -= 'a' - 'A';
			}

			// Envoyer le caractère en écho sur la sortie.
			while (!uartSendBlock(&c, 1));
		}
	}
}
